unit uUtils;

interface

uses
  Windows, Messages;

type
  { Enumration port COM  }
  TParity = ( ptNONE, ptODD, ptEVEN, ptMARK, ptSPACE );
  TStopBit = ( sbONE, sbONE5, snTWO );

  { Structure utilise par le message WM_COPYDATA  }
  PCopyData = ^TCopyData;
  TCopyData = record
      dwData: LongInt;
      cbData: LongInt;
      lpData: Pointer;
    end;

  { Structure qui va contenir nos infos  }
  PRC5Data = ^TRC5Data;
  TRC5Data = record
      Code          : string;   // reprsentation binaire de la trame
      Adresse       : string;   // l'adresse du rcepteur pour lequel est destin la trame
      Commande      : string;   // la commande
      BitControl    : integer;  // l'tat du bit de rptition
      CommandeHexa  : string;   // reprsentation hexadcimale de la commande
    end;

procedure SetDTR( hCom: THandle; Status: boolean );
procedure SetRTS( hCom: THandle; Status: boolean );
function BinToHex(BinStr: string): string;

implementation

{==============================================================================}
{   Changement d'tat de la broche DTR                                         }
{==============================================================================}
procedure SetDTR( hCom: THandle; Status: boolean );
begin
  case Status of
    true:   EscapeCommFunction( hCom, Windows.SETDTR );    // Mise  1
    false:  EscapeCommFunction( hCom, Windows.CLRDTR );    // Mise  0
  end;
end;
{==============================================================================}
{   Changement d'tat de la broche RTS                                         }
{==============================================================================}
procedure SetRTS( hCom: THandle; Status: boolean );
begin
  case Status of
    true:   EscapeCommFunction( hCom, Windows.SETRTS );    // Mise  1
    false:  EscapeCommFunction( hCom, Windows.CLRRTS );    // Mise  0
  end;
end;
{==============================================================================}
{   Convertit une valeur binaire en hexadcimal                                 }
{==============================================================================}
function BinToHex(BinStr: string): string;
const
  BinArray: array[0..15, 0..1] of string =
    (('0000', '0'), ('0001', '1'), ('0010', '2'), ('0011', '3'),
     ('0100', '4'), ('0101', '5'), ('0110', '6'), ('0111', '7'),
     ('1000', '8'), ('1001', '9'), ('1010', 'A'), ('1011', 'B'),
     ('1100', 'C'), ('1101', 'D'), ('1110', 'E'), ('1111', 'F'));
var
  Error: Boolean;
  j: Integer;
  BinPart: string;
begin
  Result:='';

  Error:=False;
  for j:=1 to Length(BinStr) do
    if not (BinStr[j] in ['0', '1']) then
      begin
        Error:=True;
        Break;
      end;

  if not Error then
    begin
      case Length(BinStr) mod 4 of
          1: BinStr:='000'+BinStr;
          2: BinStr:='00'+BinStr;
          3: BinStr:='0'+BinStr;
        end;

      while Length(BinStr)>0 do
        begin
          BinPart:=Copy(BinStr, Length(BinStr)-3, 4);
          Delete(BinStr, Length(BinStr)-3, 4);
          for j:=1 to 16 do
            if BinPart=BinArray[j-1, 0] then
              Result:=BinArray[j-1, 1]+Result;
        end;
    end;
end;

end.
