unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, uThread, uUtils, XPMan, ComCtrls, ExtCtrls, DateUtils,
  Shlobj, shellAPI;

type
  TWMPCommand = ( wmpTogglePlay, wmpStop, wmpToggleScreen, wmpToggleMute);
  TSlideShowCommand = (swStart, swStop, swNext, swPrev);

  TForm1 = class(TForm)
    btnStart: TButton;
    btnStop: TButton;
    XPManifest1: TXPManifest;
    GroupBox1: TGroupBox;
    cbComPort: TComboBox;
    GroupBox2: TGroupBox;
    StatusBar: TStatusBar;
    Label1: TLabel;
    Label2: TLabel;
    edTrameBinaire: TEdit;
    edBitRep: TEdit;
    edAddress: TEdit;
    edCommande: TEdit;
    edComHex: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
  private
    { Dclarations prives }
    dcb : _DCB;
    procedure Receive(var msg: TMessage); message WM_COPYDATA;  // procedure dclenche lors de la rception d'une trame
    procedure RemoteWMP(commande: TWMPCommand);
    procedure RemoteSlideShow(commande: TSlideShowCommand);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  Thread: TThreadRC5;   // le thread qui va servir  la surveillance du port COM
  hCom: THandle;        // handle du port COM
  bitRepOld : integer;

implementation

{$R *.dfm}
{==============================================================================}
{   Renvoie le path d'un dossier spcial de windows                            }
{==============================================================================}
function SpecialFolder(Folder: Integer): String;
var
  SFolder : pItemIDList;
  SpecialPath : Array[0..MAX_PATH] Of Char;
begin
  SHGetSpecialFolderLocation(Form1.Handle, Folder, SFolder);
  SHGetPathFromIDList(SFolder, SpecialPath);
  Result := StrPas(SpecialPath);
end;
{==============================================================================}
{   Commande du diaporama                                                      }
{==============================================================================}
procedure TForm1.RemoteSlideShow(commande: TSlideShowCommand);
var
  ShellExecuteInfo: TShellExecuteInfo;
  ExitCode: DWORD;
  ExecuteFile, ParamString: string;
  hSlideShow: HWND;
begin
  ExecuteFile :='rundll32.exe';
  ParamString := 'shimgvw.dll,ImageView_Fullscreen '+SpecialFolder(CSIDL_PERSONAL)+'\Mes images';

  FillChar(ShellExecuteInfo, SizeOf(ShellExecuteInfo), 0);
  ShellExecuteInfo.cbSize := SizeOf(TShellExecuteInfo);

  with ShellExecuteInfo do
    begin
      fMask := SEE_MASK_NOCLOSEPROCESS;
      lpFile := PChar(ExecuteFile);
      lpParameters := PChar(ParamString);
      nShow := SW_SHOWNORMAL;
    end;

  if ShellExecuteEx(@ShellExecuteInfo) then                         // on lance notre process
    begin
      WaitForInputIdle(ShellExecuteInfo.hProcess, INFINITE);        // on attend qu'il soit initialis
      hSlideShow := FindWindow('ShImgVw:CPreviewWnd', nil);         // on recherche la fentre du viewer windows
      if hSlideShow <> 0 then
        begin
          setForeGroundWindow(hSlideShow);                          // on la passe au premier plan
          sleep(500);                                               // on attend 500 ms, le temps qu'elle prenne le focus

          case commande of
            swStart:
              begin
                keybd_event(VK_F11, 0, 0, 0);
                keybd_event(VK_F11, 0, KEYEVENTF_KEYUP, 0);
              end;
            swStop:
              begin
                keybd_event(VK_ESCAPE, 0, 0, 0);
                keybd_event(VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);
              end;
            swNext:
              begin
                keybd_event(VK_LEFT, 0, 0, 0);
                keybd_event(VK_LEFT, 0, KEYEVENTF_KEYUP, 0);
              end;
            swPrev:
              begin
                keybd_event(VK_LEFT, 0, 0, 0);
                keybd_event(VK_LEFT, 0, KEYEVENTF_KEYUP, 0);
              end;
          end;
        end;
    end;
end;
{==============================================================================}
{   Commande de Windows Media Player                                           }
{==============================================================================}
procedure TForm1.RemoteWMP(commande: TWMPCommand);
var
  hMediaPlayer: HWND;
  hWinForeground: HWND;
begin
  if hMediaPlayer = 0 then FindWindow('WMPlayerApp', nil);
  if hMediaPlayer <> 0 then
    begin
      hWinForeground := getForegroundWindow();
      if hWinForeground <> hMediaPlayer then
        setForeGroundWindow(hMediaPlayer);
      sleep(10);
      case commande of
          wmpTogglePlay:
            begin
              keybd_event(VK_CONTROL, 0, 0, 0);
              keybd_event(80, 0, 0, 0);
              keybd_event(80, 0, KEYEVENTF_KEYUP, 0);
              keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
            end;
          wmpStop:
            begin
              keybd_event(VK_CONTROL, 0, 0, 0);
              keybd_event(83, 0, 0, 0);
              keybd_event(83, 0, KEYEVENTF_KEYUP, 0);
              keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
            end;
          wmpToggleScreen:
            begin
              keybd_event(VK_MENU, 0, 0, 0);
              keybd_event(VK_RETURN, 0, 0, 0);
              keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);
              keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0);
            end;
          wmpToggleMute:
            begin
              keybd_event(VK_F8, 0, 0, 0);
              keybd_event(VK_F8, 0, KEYEVENTF_KEYUP, 0);
            end;
        end;
    end;
end;
{==============================================================================}
{   Rception d'une trame RC5                                                  }
{==============================================================================}
procedure TForm1.Receive(var msg: TMessage);
begin
  // Quand on reois le message de rception, on dcortique le message pour extraire notre structure qui contient les infos sur la trame
  with PRC5Data(PCopyData(msg.LParam)^.lpData)^ do
    begin
      edTrameBinaire.Text := Code;            // reprsentation binaire de la trame
      edBitRep.Text := intToStr(BitControl);  // l'tat du bit de rptition
      edAddress.Text := Adresse;              // l'adresse du rcepteur pour lequel tait destin cette trame
      edCommande.Text := Commande;            // la commande
      edComHex.Text := CommandeHexa;          // reprsentation hexadcimale de la commande

      { si le rcepteur est le lecteur multimedia }
      if (CommandeHexa = '01') and (Adresse = '00000') then RemoteWMP(wmpTogglePlay)        // touche 1
      else if (CommandeHexa = '02') and (Adresse = '00000') then RemoteWMP(wmpStop)         // touche 2
      else if (CommandeHexa = '03') and (Adresse = '00000') then RemoteWMP(wmpToggleScreen) // touche 3
      else if (CommandeHexa = '04') and (Adresse = '00000') then RemoteWMP(wmpToggleMute);  // touche 4

      { si le rcepteur est le diaporama }
      if (CommandeHexa = '01') and (Adresse = '00101') then RemoteSlideShow(swStart)        // touche 1
      else if (CommandeHexa = '02') and (Adresse = '00101') then RemoteSlideShow(swStop)    // touche 2
      else if (CommandeHexa = '03') and (Adresse = '00101') then RemoteSlideShow(swPrev)    // touche 3
      else if (CommandeHexa = '04') and (Adresse = '00101') then RemoteSlideShow(swNext);   // touche 4

    end;
end;
{==============================================================================}
{   Connection  notre rcepteur                                               }
{==============================================================================}
procedure TForm1.btnStartClick(Sender: TObject);
begin
  { Ouverture du port COM }
  hcom := CreateFile(pChar(cbComPort.Text), GENERIC_READ, 0, nil, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);

  { Configuration du port COM  }
  dcb.BaudRate := 9600;
  dcb.StopBits := DWord(sbOne) ;
  dcb.Parity := DWord(ptNone) ;
  dcb.ByteSize := 8 ;

  if (hcom = INVALID_HANDLE_VALUE) then
    begin
      // Si l'ouverture  choue, on affiche le message d'erreur et on quitte la procedure
      Application.MessageBox(PChar(SysErrorMessage(GetLastError())),'');
      exit;
    end
  else StatusBar.Panels[0].Text := 'Connect';

  { Application de la configuration au port COM }
  if not SetCommState(hcom,dcb) then StatusBar.Panels[0].Text := 'Erreur lors de l''initialisation';

  SetDTR(hCom, true);                         // On met la ligne DTR  1 (Suivant les rcepteurs)
  setRTS(hCom, true);                         // On met la ligne RTS  1 (Suivant les rcepteurs)

  //Et enfin on lance notre thread qui va surveiller ce qui arrive sur le port COM
  Thread := TThreadRC5.Create(Handle, hCom);
end;
{==============================================================================}
{   Dconnection                                                               }
{==============================================================================}
procedure TForm1.btnStopClick(Sender: TObject);
begin
  // Si le thread est dj lan, on le termine
  if Thread <> nil then Thread.Terminate;
  CloseHandle(hCom);                          // on ferme la connection au port COM
  StatusBar.Panels[0].Text := 'Dconnect';
end;

end.
